//----------------------------------------------------------------------------------------------------------------------
//ATmega48,ATmega88,ATmega168
//----------------------------------------------------------------------------------------------------------------------

#ifndef __MEGA48IO_H__
#define __MEGA48IO_H__

//----------------------------------------------------------------------------------------------------------------------
//	rbg`
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char b0:1;
		unsigned char b1:1;
		unsigned char b2:1;
		unsigned char b3:1;
		unsigned char b4:1;
		unsigned char b5:1;
		unsigned char b6:1;
		unsigned char b7:1;
	}bit;
	unsigned char byte;
}U_B;

typedef union{
	struct{
		unsigned short b0 :1;
		unsigned short b1 :1;
		unsigned short b2 :1;
		unsigned short b3 :1;
		unsigned short b4 :1;
		unsigned short b5 :1;
		unsigned short b6 :1;
		unsigned short b7 :1;
		unsigned short b8 :1;
		unsigned short b9 :1;
		unsigned short b10:1;
		unsigned short b11:1;
		unsigned short b12:1;
		unsigned short b13:1;
		unsigned short b14:1;
		unsigned short b15:1;
	}bit;
	unsigned short word;
}U_W;

//----------------------------------------------------------------------------------------------------------------------
//	bot
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _C:1;						//LtO
		unsigned char _Z:1;						//[tO
		unsigned char _N:1;						//lKeButO
		unsigned char _V:1;						//I[o[ttO
		unsigned char _S:1;						//TCtO
		unsigned char _H:1;						//n[tL[tO
		unsigned char _T:1;						//rbgϐ
		unsigned char _I:1;						//i1:j
	}bit;
	unsigned char byte;
}U_SREG;
#define B_SREG   (*(volatile U_SREG    *)0x5f)	//Xe[^X

#define B_SP     (*(volatile U_W       *)0x5d)	//X^bN|C^
#define B_SPL    (*(volatile U_B       *)0x5d)	//X^bN|C^k
#define B_SPH    (*(volatile U_B       *)0x5e)	//X^bN|C^g

//----------------------------------------------------------------------------------------------------------------------
//	ddoqnl
//----------------------------------------------------------------------------------------------------------------------

#define B_EEAR   (*(volatile U_W       *)0x41)	//AhX
#define B_EEARL  (*(volatile U_B       *)0x41)	//AhXk
#define B_EEARH  (*(volatile U_B       *)0x42)	//AhXg

#define B_EEDR   (*(volatile U_B       *)0x40)	//f[^

typedef union{
	struct{
		unsigned char _EERE :1;					//Ǎ
		unsigned char _EEPE :1;					//
		unsigned char _EEMPE:1;					//}X^
		unsigned char _EERIE:1;					//\i1:j
		unsigned char _EEPM :2;					//[h
	}bit;
	unsigned char byte;
}U_EECR;
#define B_EECR   (*(volatile U_EECR    *)0x3f)	//䃌WX^

//----------------------------------------------------------------------------------------------------------------------
//	fohn
//----------------------------------------------------------------------------------------------------------------------

#define B_GPIOR0 (*(volatile U_B       *)0x3e)	//fohnO
#define B_GPIOR1 (*(volatile U_B       *)0x4a)	//fohnP
#define B_GPIOR2 (*(volatile U_B       *)0x4b)	//fohnQ

//----------------------------------------------------------------------------------------------------------------------
//	NbN
//----------------------------------------------------------------------------------------------------------------------

#define B_OSCCAL (*(volatile U_B       *)0x66)	//UZ

typedef union{
	struct{
		unsigned char _CLKPS :4;				//vXP[I
		unsigned char _DUMY  :3;				//gp
		unsigned char _CLKPCE:1;				//vXP[ύX
	}bit;
	unsigned char byte;
}U_CLKPR;
#define B_CLKPR  (*(volatile U_CLKPR   *)0x61)	//vXP[

//----------------------------------------------------------------------------------------------------------------------
//	dǗ
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _SE:1;					//X[v
		unsigned char _SM:3;					//X[v[h
	}bit;
	unsigned char byte;
}U_SMCR;
#define B_SMCR   (*(volatile U_SMCR    *)0x53)	//X[v

typedef union{
	struct{
		unsigned char _PRADC   :1;				//ADCϊ@~
		unsigned char _PRUSART0:1;				//USART0~
		unsigned char _PRSPI   :1;				//SPI~
		unsigned char _PRTIM1  :1;				//^C}P~
		unsigned char _DUMY    :1;				//gp
		unsigned char _PRTIM0  :1;				//^C}O~
		unsigned char _PRTIM2  :1;				//^C}Q~
		unsigned char _PRTWI   :1;				//svh~
	}bit;
	unsigned char byte;
}U_PRR;
#define B_PRR    (*(volatile U_PRR     *)0x64)	//ȓd̓[h

//----------------------------------------------------------------------------------------------------------------------
//	VXe
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _PORF :1;
		unsigned char _EXTRF:1;
		unsigned char _BORF :1;
		unsigned char _WDRF :1;
	}bit;
	unsigned char byte;
}U_MCUSR;
#define B_MCUSR  (*(volatile U_MCUSR   *)0x54)

typedef union{
	struct{
		unsigned char _WDP0:1;
		unsigned char _WDP1:1;
		unsigned char _WDP2:1;
		unsigned char _WDE :1;
		unsigned char _WDCE:1;
		unsigned char _WDP3:1;
		unsigned char _WDIE:1;
		unsigned char _WDIF:1;
	}bit;
	unsigned char byte;
}U_WDTCSR;
#define B_WDTCSR (*(volatile U_WDTCSR  *)0x60)

typedef union{
	struct{
		unsigned char _IVCE :1;
		unsigned char _IVSEL:1;
		unsigned char _DUMY :1;
		unsigned char _PUD  :1;
	}bit;
	unsigned char byte;
}U_MCUCR;
#define B_MCUCR  (*(volatile U_MCUCR   *)0x55)

//------------------------------------------------------------------------------------------------------------------------------
//	h^n|[g
//------------------------------------------------------------------------------------------------------------------------------

#define B_PINB   (*(volatile const U_B *)0x23)	//|[ga
#define B_NOTB   (*(volatile U_B       *)0x23)	//|[gao͔]i1:]j
#define B_DDRB   (*(volatile U_B       *)0x24)	//|[gao͐ؑցi0:́j
#define B_PORTB  (*(volatile U_B       *)0x25)	//|[gao

#define B_PINC   (*(volatile const U_B *)0x26)	//|[gb
#define B_NOTC   (*(volatile U_B       *)0x26)	//|[gbo͔]i1:]j
#define B_DDRC   (*(volatile U_B       *)0x27)	//|[gbo͐ؑցi0:́j
#define B_PORTC  (*(volatile U_B       *)0x28)	//|[gbo

#define B_PIND   (*(volatile const U_B *)0x29)	//|[gc
#define B_NOTD   (*(volatile U_B       *)0x29)	//|[gco͔]i1:]j
#define B_DDRD   (*(volatile U_B       *)0x2a)	//|[gco͐ؑցi0:́j
#define B_PORTD  (*(volatile U_B       *)0x2b)	//|[gco

//------------------------------------------------------------------------------------------------------------------------------
//	O
//------------------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _ISC0:2;					//OO
		unsigned char _ISC1:2;					//OP
	}bit;
	unsigned char byte;
}U_EICRA;
#define B_EICRA  (*(volatile U_EICRA   *)0x69)	//O

typedef union{
	struct{
		unsigned char _INT0:1;					//OOi1:j
		unsigned char _INT1:1;					//OPi1:j
	}bit;
	unsigned char byte;
}U_EIMSK;
#define B_EIMSK  (*(volatile U_EIMSK   *)0x3d)	//O

typedef union{
	struct{
		unsigned char _INTF0:1;					//OOtOi1:vj
		unsigned char _INTF1:1;					//OPtOi1:vj
	}bit;
	unsigned char byte;
}U_EIFR;
#define B_EIFR   (*(volatile U_EIFR    *)0x3c)	//OtO

typedef union{
	struct{
		unsigned char _PCIE0:1;					//sωOi1:j
		unsigned char _PCIE1:1;					//sωPi1:j
		unsigned char _PCIE2:1;					//sωQi1:j
	}bit;
	unsigned char byte;
}U_PCICR;
#define B_PCICR  (*(volatile U_PCICR   *)0x68)	//sω

typedef union{
	struct{
		unsigned char _PCIF0:1;					//sωOtOi1:vj
		unsigned char _PCIF1:1;					//sωPtOi1:vj
		unsigned char _PCIF2:1;					//sωQtOi1:vj
	}bit;
	unsigned char byte;
}U_PCIFR;
#define B_PCIFR  (*(volatile U_PCIFR   *)0x3b)	//sωtO

typedef union{
	struct{
		unsigned char _PCINT0:1;
		unsigned char _PCINT1:1;
		unsigned char _PCINT2:1;
		unsigned char _PCINT3:1;
		unsigned char _PCINT4:1;
		unsigned char _PCINT5:1;
		unsigned char _PCINT6:1;
		unsigned char _PCINT7:1;
	}bit;
	unsigned char byte;
}U_PCMSK0;

#define B_PCMSK0 (*(volatile U_PCMSK0  *)0x6b)

typedef union{
	struct{
		unsigned char _PCINT8 :1;
		unsigned char _PCINT9 :1;
		unsigned char _PCINT10:1;
		unsigned char _PCINT11:1;
		unsigned char _PCINT12:1;
		unsigned char _PCINT13:1;
		unsigned char _PCINT14:1;
	}bit;
	unsigned char byte;
}U_PCMSK1;
#define B_PCMSK1 (*(volatile U_PCMSK1  *)0x6c)

typedef union{
	struct{
		unsigned char _PCINT16:1;
		unsigned char _PCINT17:1;
		unsigned char _PCINT18:1;
		unsigned char _PCINT19:1;
		unsigned char _PCINT20:1;
		unsigned char _PCINT21:1;
		unsigned char _PCINT22:1;
		unsigned char _PCINT23:1;
	}bit;
	unsigned char byte;
}U_PCMSK2;
#define B_PCMSK2 (*(volatile U_PCMSK2  *)0x6d)

//----------------------------------------------------------------------------------------------------------------------
//	^C}O
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _WGM001:2;				//g`[hOAP
		unsigned char _DUMY :2;					//gp
		unsigned char _COM0B:2;					//RyAao̓[h
		unsigned char _COM0A:2;					//RyA`o̓[h
	}bit;
	unsigned char byte;
}U_TCCR0A;
#define B_TCCR0A (*(volatile U_TCCR0A  *)0x44)	//`

typedef union{
	struct{
		unsigned char _CS0  :3;					//̓NbNI
		unsigned char _WGM02:1;					//g`[hQ
		unsigned char _DUMY :2;					//gp
		unsigned char _FOC0B:1;					//RyAa쎷s
		unsigned char _FOC0A:1;					//RyA`쎷s
	}bit;
	unsigned char byte;
}U_TCCR0B;
#define B_TCCR0B (*(volatile U_TCCR0B  *)0x45)	//a

#define B_TCNT0  (*(volatile U_B       *)0x46)	//JE^

#define B_OCR0A  (*(volatile U_B       *)0x47)	//RyAa

#define B_OCR0B  (*(volatile U_B       *)0x48)	//RyA`

typedef union{
	struct{
		unsigned char _TOIE0 :1;				//I[o[t[i1:j
		unsigned char _OCIE0A:1;				//r`        i1:j
		unsigned char _OCIE0B:1;				//ra        i1:j
	}bit;
	unsigned char byte;
}U_TIMSK0;
#define B_TIMSK0 (*(volatile U_TIMSK0  *)0x6e)	//

typedef union{
	struct{
		unsigned char _TOV0 :1;					//I[o[t[tOi1:vj
		unsigned char _OCF0A:1;					//r`tO        i1:vj
		unsigned char _OCF0B:1;					//ratO        i1:vj
	}bit;
	unsigned char byte;
}U_TIFR0;
#define B_TIFR0  (*(volatile U_TIFR0   *)0x35)	//tO

//----------------------------------------------------------------------------------------------------------------------
//	^C}OAPAQvXP[
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _PSRSYNC:1;				//^C}OCPvXP[Zbg
		unsigned char _PSRASY :1;				//^C}QvXP[Zbg
		unsigned char _DUMY   :5;				//gp
		unsigned char _TSM    :1;				//^C}
	}bit;
	unsigned char byte;
}U_GTCCR;
#define B_GTCCR  (*(volatile U_GTCCR   *)0x43)	//JE^

//----------------------------------------------------------------------------------------------------------------------
//	^C}P
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _WGM101:2;				//g`[hOAP
		unsigned char _DUMY  :2;				//gp
		unsigned char _COM1B :2;				//RyAao̓[h
		unsigned char _COM1A :2;				//RyA`o̓[h
	}bit;
	unsigned char byte;
}U_TCCR1A;
#define B_TCCR1A (*(volatile U_TCCR1A  *)0x80)	//`

typedef union{
	struct{
		unsigned char _CS1   :3;				//̓NbNI
		unsigned char _WGM123:2;				//g`[hQAR
		unsigned char _DUMY  :1;				//gp
		unsigned char _ICES1 :1;				//RyAa쎷s
		unsigned char _ICNC1 :1;				//RyA`쎷s
	}bit;
	unsigned char byte;
}U_TCCR1B;
#define B_TCCR1B (*(volatile U_TCCR1B  *)0x81)	//a

typedef union{
	struct{
		unsigned char _DUMY :6;					//gp
		unsigned char _FOC1B:1;					//RyAa쎷s
		unsigned char _FOC1A:1;					//RyA`쎷s
	}bit;
	unsigned char byte;
}U_TCCR1C;
#define B_TCCR1C (*(volatile U_TCCR1C  *)0x82)	//a

#define B_TCNT1  (*(volatile U_W       *)0x84)
#define B_TCNT1L (*(volatile U_B       *)0x84)
#define B_TCNT1H (*(volatile U_B       *)0x85)

#define B_OCR1A  (*(volatile U_W       *)0x88)
#define B_OCR1AL (*(volatile U_B       *)0x88)
#define B_OCR1AH (*(volatile U_B       *)0x89)
#define B_OCR1B  (*(volatile U_W       *)0x8A)
#define B_OCR1BL (*(volatile U_B       *)0x8A)
#define B_OCR1BH (*(volatile U_B       *)0x8B)

#define B_ICR1   (*(volatile U_W       *)0x86)
#define B_ICR1L  (*(volatile U_B       *)0x86)
#define B_ICR1H  (*(volatile U_B       *)0x87)

typedef union{
	struct{
		unsigned char _TOIE1 :1;
		unsigned char _OCIE1A:1;
		unsigned char _OCIE1B:1;
		unsigned char _DUMY  :2;
		unsigned char _ICIE1 :1;
	}bit;
	unsigned char byte;
}U_TIMSK1;
#define B_TIMSK1 (*(volatile U_TIMSK1  *)0x6f)

typedef union{
	struct{
		unsigned char _TOV1 :1;
		unsigned char _OCF1A:1;
		unsigned char _OCF1B:1;
		unsigned char _DUMY :2;
		unsigned char _ICF1 :1;
	}bit;
	unsigned char byte;
}U_TIFR1;
#define B_TIFR1  (*(volatile U_TIFR1   *)0x36)	//tO

//----------------------------------------------------------------------------------------------------------------------
//	^C}Q
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _WGM201:2;
		unsigned char _DUMY  :2;
		unsigned char _COM2B :2;
		unsigned char _COM2A :2;
	}bit;
	unsigned char byte;
}U_TCCR2A;
#define B_TCCR2A (*(volatile U_TCCR2A  *)0xb0)

typedef union{
	struct{
		unsigned char _CS2  :3;
		unsigned char _WGM22:1;
		unsigned char _DUMY :2;
		unsigned char _FOC2B:1;
		unsigned char _FOC2A:1;
	}bit;
	unsigned char byte;
}U_TCCR2B;
#define B_TCCR2B (*(volatile U_TCCR2B  *)0xb1)

#define B_TCNT2  (*(volatile U_B       *)0xb2)
#define B_OCR2A  (*(volatile U_B       *)0xb3)
#define B_OCR2B  (*(volatile U_B       *)0xb4)

typedef union{
	struct{
		unsigned char _TOIE2 :1;
		unsigned char _OCIE2A:1;
		unsigned char _OCIE2B:1;
	}bit;
	unsigned char byte;
}U_TIMSK2;
#define B_TIMSK2 (*(volatile U_TIMSK2  *)0x70)

typedef union{
	struct{
		unsigned char _TOV2 :1;
		unsigned char _OCF2A:1;
		unsigned char _OCF2B:1;
	}bit;
	unsigned char byte;
}U_TIFR2;
#define B_TIFR2  (*(volatile U_TIFR2   *)0x37)	//tO

typedef union{
	struct{
		unsigned char _TCR2BUB:1;
		unsigned char _TCR2AUB:1;
		unsigned char _OCR2BUB:1;
		unsigned char _OCR2AUB:1;
		unsigned char _TCN2UB :1;
		unsigned char _AS2    :1;
		unsigned char _EXCLK  :1;
	}bit;
	unsigned char byte;
}U_ASSR;
#define B_ASSR   (*(volatile U_ASSR    *)0xb6)

//----------------------------------------------------------------------------------------------------------------------
//	roh
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _SPR0:1;
		unsigned char _SPR1:1;
		unsigned char _CPHA:1;
		unsigned char _CPOL:1;
		unsigned char _MSTR:1;
		unsigned char _DORD:1;
		unsigned char _SPE :1;
		unsigned char _SPIE:1;
	}bit;
	unsigned char byte;
}U_SPCR;
#define B_SPCR   (*(volatile U_SPCR    *)0x4c)

typedef union{
	struct{
		unsigned char _SPI2X:1;
		unsigned char _DUMY :5;
		unsigned char _WCOL :1;
		unsigned char _SPIF :1;
	}bit;
	unsigned char byte;
}U_SPSR;
#define B_SPSR   (*(volatile U_SPSR    *)0x4d)

#define B_SPDR   (*(volatile U_B       *)0x4e)

//----------------------------------------------------------------------------------------------------------------------
//	tr`qs
//----------------------------------------------------------------------------------------------------------------------

#define B_UDR0   (*(volatile U_B       *)0xc6)

typedef union{
	struct{
		unsigned char _MPCM:1;
		unsigned char _U2X :1;
		unsigned char _UPE :1;
		unsigned char _DOR :1;
		unsigned char _FE  :1;
		unsigned char _UDRE:1;
		unsigned char _TXC :1;
		unsigned char _RXC :1;
	}bit;
	unsigned char byte;
}U_UCSRA;
#define B_UCSR0A (*(volatile U_UCSRA   *)0xc0)

typedef union{
	struct{
		unsigned char _TXB8 :1;
		unsigned char _RXB8 :1;
		unsigned char _UCSZ2:1;
		unsigned char _TXEN :1;
		unsigned char _RXEN :1;
		unsigned char _UDRIE:1;
		unsigned char _TXCIE:1;
		unsigned char _RXCIE:1;
	}bit;
	unsigned char byte;
}U_UCSRB;
#define B_UCSR0B (*(volatile U_UCSRB   *)0xc1)

typedef union{
	struct{
		unsigned char _UCPOL:1;
		unsigned char _UCSZ0:1;
		unsigned char _UCSZ1:1;
		unsigned char _USBS :1;
		unsigned char _UPM  :2;
		unsigned char _UMSEL:2;
	}bit;
	unsigned char byte;
}U_UCSRC;
#define B_UCSR0C (*(volatile U_UCSRC   *)0xc2)

#define B_UBRR0  (*(volatile U_W       *)0xc4)
#define B_UBRR0L (*(volatile U_B       *)0xc4)
#define B_UBRR0H (*(volatile U_B       *)0xc5)

//----------------------------------------------------------------------------------------------------------------------
//	tr`qsiroh[hj
//----------------------------------------------------------------------------------------------------------------------








//----------------------------------------------------------------------------------------------------------------------
//	svh
//----------------------------------------------------------------------------------------------------------------------

#define B_TWBR   (*(volatile U_B       *)0xb8)

typedef union{
	struct{
		unsigned char _TWIE :1;
		unsigned char _DUMY :1;
		unsigned char _TWEN :1;
		unsigned char _TWWC :1;
		unsigned char _TWSTO:1;
		unsigned char _TWSTA:1;
		unsigned char _TWEA :1;
		unsigned char _TWINT:1;
	}bit;
	unsigned char byte;
}U_TWCR;
#define B_TWCR   (*(volatile U_TWCR    *)0xbc)

typedef union{
	struct{
		unsigned char _TWPS:2;
		unsigned char _DUMY:1;
		unsigned char _TWS :5;
	}bit;
	unsigned char byte;
}U_TWSR;
#define B_TWSR   (*(volatile U_TWSR    *)0xb9)

#define B_TWDR   (*(volatile U_B       *)0xbb)

typedef union{
	struct{
		unsigned char _TWGCE:1;
		unsigned char _TWA  :7;
	}bit;
	unsigned char byte;
}U_TWAR;
#define B_TWAR   (*(volatile U_TWAR    *)0xba)

typedef union{
	struct{
		unsigned char _DUMY:1;
		unsigned char _TWAM:7;
	}bit;
	unsigned char byte;
}U_TWAMR;
#define B_TWAMR  (*(volatile U_TWAMR   *)0xbd)

//----------------------------------------------------------------------------------------------------------------------
//	AiORp[^
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _ACIS:2;
		unsigned char _ACIC:1;
		unsigned char _ACIE:1;
		unsigned char _ACI :1;
		unsigned char _ACO :1;
		unsigned char _ACBG:1;
		unsigned char _ACD :1;
	}bit;
	unsigned char byte;
}U_ACSR;
#define B_ACSR   (*(volatile U_ACSR    *)0x50)

typedef union{
	struct{
		unsigned char _AIN0D:1;
		unsigned char _AIN1D:1;
	}bit;
	unsigned char byte;
}U_DIDR1;
#define B_DIDR1  (*(volatile U_DIDR1   *)0x7f)

//----------------------------------------------------------------------------------------------------------------------
//	`^cRo[^
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _MUX  :4;
		unsigned char _DUMY :1;
		unsigned char _ADLAR:1;
		unsigned char _REFS :2;
	}bit;
	unsigned char byte;
}U_ADMUX;
#define B_ADMUX  (*(volatile U_ADMUX   *)0x7c)

typedef union{
	struct{
		unsigned char _ADPS :3;
		unsigned char _ADIE :1;
		unsigned char _ADIF :1;
		unsigned char _ADATE:1;
		unsigned char _ADSC :1;
		unsigned char _ADEN :1;
	}bit;
	unsigned char byte;
}U_ADCSRA;
#define B_ADCSRA (*(volatile U_ADCSRA  *)0x7a)

#define B_ADC    (*(volatile U_W       *)0x78)
#define B_ADCL   (*(volatile U_B       *)0x78)
#define B_ADCH   (*(volatile U_B       *)0x79)

typedef union{
	struct{
		unsigned char _ADTS:3;
		unsigned char _DUMY:3;
		unsigned char _ACME:1;
	}bit;
	unsigned char byte;
}U_ADCSRB;
#define B_ADCSRB (*(volatile U_ADCSRB  *)0x7b)

typedef union{
	struct{
		unsigned char _ADC0D:1;
		unsigned char _ADC1D:1;
		unsigned char _ADC2D:1;
		unsigned char _ADC3D:1;
		unsigned char _ADC4D:1;
		unsigned char _ADC5D:1;
	}bit;
	unsigned char byte;
}U_DIDR0;
#define B_DIDR0  (*(volatile U_DIDR0   *)0x7e)

//----------------------------------------------------------------------------------------------------------------------
//	ZtvO~O
//----------------------------------------------------------------------------------------------------------------------

typedef union{
	struct{
		unsigned char _SELFPRGEN:1;
		unsigned char _PGERS    :1;
		unsigned char _PGWRT    :1;
		unsigned char _BLBSET   :1;
		unsigned char _RWWSRE   :1;
		unsigned char _DUMY     :1;
		unsigned char _RWWSB    :1;
		unsigned char _SPMIE    :1;
	}bit;
	unsigned char byte;
}U_SPMCSR;
#define B_SPMCSR (*(volatile U_SPMCSR  *)0x57)

//----------------------------------------------------------------------------------------------------------------------

#endif //__MEGA48IO_H__
